'
'STARDATE script v1.1
'
'THE Star Trek stardate script for Samurize!
'
'Author: QuippeR
'
'Source: David Trimboli (http://members.aol.com/dtrimboli/stardate.html)
'Fully after his Pascal source code
'
'v1.1 changes:
'-fixed AM/PM bug
'
'
'Change your timezone here in the script. Make an active script meter. Select the stardate function. Change # of Decimals to 1. Run it every 15 mins or so. Have fun with it!
'
'..............................................
'

TIMEZONE = 1

'put your timezone here!
'	e.g.: TIMEZONE = 1 means you're in the timezone GMT+1
'...............................................
'--------------Don't change after this line!!---
'===============================================
'

DAYS_YEAR = 365.25
DAYS_CENTURY = 36525

'...............................................
'-------------------------------Main function---
'===============================================
'

function StarDate()
	actYear = year(now())
	actMonth = month(now())
	actDay = day(now())
	temp = time()
	actHour = left(temp,instr(temp,":")-1)
	actMin = right(left(temp,instrRev(temp,":")-1),instr(temp,":")-1)
	actSec = right(temp,len(temp)-instrrev(temp,":"))
	if len(actSec)>2 then
		AMPM = right(actSec,2)
		actSec = left(actSec,2)
		if AMPM = "PM" then
			actHour = actHour + 12
		end if
	end if

	LastLeap = LeapYear(actYear)

	Days = DaysUp2LeapYear(LastLeap) + DaysSinceLeapYear(actYear,LastLeap) + DaysUp2Month(actYear,actMonth) + DaysInMonth(actDay) +	FractionOfDay(actHour,actMin,actSec)

	StarDate = (Days/DAYS_CENTURY)*100000
end function


'...............................................
'------------------------------------Privates---
'===============================================
'

private function LeapYear(Year)
	tempY = Year
	do while tempY mod 4<>0
		tempY = tempY-1
	loop
	LeapYear = tempY mod 100
end function


private function DaysUp2LeapYear(LeapYear)
	DaysUp2LeapYear = DAYS_YEAR*LeapYear
end function


private function DaysSinceLeapYear(Year , LeapYear)
	temp = LeapYear
	temp2 = Year mod 100
	days = 0
	do while temp <> temp2
		days = days + 365
		if temp = LeapYear then
			days = days + 1
		end if
		temp = temp + 1
	loop
	DaysSinceLeapYear = days
end function


private function DaysUp2Month(Year, Month)
	MonthIndex = 1
	days = 0
	do while (Month - MonthIndex) <> 0
		if instr("1357810",MonthIndex) <> 0 then	'easier then case...
			days = days + 31
		elseif instr("46911",MonthIndex) <> 0 then
			days = days + 30
		elseif Year mod 4 = 0 then
			days = days + 29
		else
			days = days + 28
		end if
		MonthIndex = MonthIndex + 1
	loop
	DaysUp2Month = days
end function

private function DaysInMonth(Day)
	DaysInMonth = Day - 1
end function

' DST not supported. I'm not a perfectionist...

private function FractionOfDay(localHour, Min, Sec)
	GMTHour = localHour + TIMEZONE
	temp = GMTHour / 24
	temp = temp + (Min/60)/24
	temp = temp + (Sec/3600)/24
	FractionOfDay = temp
end function


'EOF
